
#include "GReAT.h"
#pragma warning (disable : 4786) // Names more than 255 characters

#define PRINTDEPTH "    "

HINSTANCE hCINTDLL = 0;

GReAT::GReAT() : backendMap(0), 
          grTransformation(0),
          m_dbgNotify(0),
          m_ctrlNotify(0)
{}


GReAT::~GReAT()
{
}
//=================================
void GReAT::setDebugNotify(IDebugNotify* dbgNotify)
{
  m_dbgNotify = dbgNotify;
}
//=================================
void    GReAT::setCtrlNotify(ICtrlNotify* ctrlNotify)
{
  m_ctrlNotify = ctrlNotify;
}

//=================================

void GReAT::init(GeneralBackendPtr  dataNetworkMap, 
                 Udm::DataNetwork *Transformation)
{
 
	depth = 0;
	backendMap = dataNetworkMap;
	grTransformation = Transformation;
	
	// Code to generate the cint code file and load it
	/*GR::RootFolder rf = GR::RootFolder::Cast(grTransformation->GetRootObject());
	rf.Accept(cintCodeGatherer);
	
	if(system("nmake -f %GREAT_PATH%\\etc\\Gz__cint_code_generated.mak") == -1)
	{	// Error
		cerr << "Dll didnt compile and link \n";
	}
	
	hDLL = LoadLibrary(cintCodeGatherer.GetDllName().c_str());
	*/
}

void GReAT::setCINTDll(HINSTANCE hDLL)
{
 hCINTDLL = hDLL;
}

void GReAT::ConvertPacket(const PassAlongPacket& p, const GR::RuleBase& dstRule, PassAlongPacket& newp)
{
	for(PassAlongPacket::const_iterator i = p.begin(); i != p.end(); ++i)
	{	
		const GR::ObjectWrapper& or = (*i).first;
		set<GR::PassAlong> pas = or.dstObjectWrapper();
		for(set<GR::PassAlong>::const_iterator j=pas.begin(); j!= pas.end() ; ++j)
		{
			const GR::ObjectWrapper& dor = (*j).dstObjectWrapper_end();
			GR::RuleBase dorp;
			const string& nn = dor.type().name();
			if(nn == "ObjectWrapperProxy")
			{	
				const GR::ObjectWrapperProxy& dorpr = GR::ObjectWrapperProxy::Cast(dor);
				dorp = dorpr.RewritingRuleProxy_parent();
			}
			else
			{	
				dorp = dor.RewritingRule_parent();
			}

			if(dstRule == dorp)	newp[dor] = (*i).second;   
		}
	}
}

void GReAT::ConvertPackets(const PassAlongPackets& ps,const GR::RuleBase& dstRule, PassAlongPackets& newps)
{
	PassAlongPackets currps;
	
	for(PassAlongPackets::const_iterator i=ps.begin(); i!=ps.end(); ++i)
	{	
		PassAlongPacket newp;
		ConvertPacket(*i, dstRule, newp);
		if(newp.size() > 0)	newps.push_back(newp);
	}

	RemoveDuplicates(newps);
}

//PassAlongPackets GReAT::RemoveDuplicates(PassAlongPackets ps) //kalmar: faster 
void GReAT::RemoveDuplicates(PassAlongPackets& ps)
{	
	PassAlongPackets::iterator i=ps.begin(); 
	while(i!=ps.end())
	{	
		PassAlongPackets::iterator j=i;
		j++;
		while(j!=ps.end())
		{	
			PassAlongPackets::iterator k = j;
			j++;
			if(CheckDuplicate(*i, *k))
			{	
				ps.erase(k);
				continue;
			}
		}
		++i;
	}
//You can use set here.
}

bool GReAT::CheckDuplicate(PassAlongPacket& p1, PassAlongPacket& p2)
{	
	if(p1.size() != p2.size())	return false;
	for(PassAlongPacket::const_iterator i = p1.begin(); i != p1.end(); ++i)
	{	
		PassAlongPacket::iterator j = p2.find((*i).first);
		if(j==p2.end())	return false;

		if((*i).second != (*j).second) return false;
	}

	return true;
}

void GReAT::ConvertPacketFromRefToRule(const PassAlongPacket& p,const GR::RuleBase& dstRule, PassAlongPacket& newp)
{
	for(PassAlongPacket::const_iterator i = p.begin(); i != p.end(); ++i)
	{	
		const GR::ObjectWrapperProxy& or = GR::ObjectWrapperProxy::Cast((*i).first);
		if(or == Udm::null) continue;
	
		const GR::ObjectWrapper& pas = or.refersTo();
		//ASSERT(pas!=Udm::null)
		if(pas == Udm::null) continue;
		newp[pas] = (*i).second;
	}
}

void GReAT::ConvertPacketsFromRefToRule(const PassAlongPackets& ps,const GR::RuleBase& dstRule, PassAlongPackets& newps)
{
	for(PassAlongPackets::const_iterator i=ps.begin(); i!=ps.end(); ++i)
	{	
		PassAlongPacket newp;
		ConvertPacketFromRefToRule(*i, dstRule, newp);
		if(newp.size() > 0)	newps.push_back(newp);
	}
}

void GReAT::ConvertPacketFromRuleToRef(const PassAlongPacket& p,const GR::RuleBase& dstRule,PassAlongPacket& newp)
{
	const GR::RewritingRuleProxy& dstRulep = GR::RewritingRuleProxy::Cast(dstRule);
	
	if(dstRulep==Udm::null)  return;

	const set<GR::ObjectWrapperProxy>& objs = dstRulep.ObjectWrapperProxy_children();
	for(set<GR::ObjectWrapperProxy>::const_iterator i=objs.begin(); i!=objs.end(); ++i)
	{	
		const GR::ObjectWrapperProxy& orp = *i;
		const GR::ObjectWrapper& or = orp.refersTo();
		PassAlongPacket::const_iterator it = p.find(or);
		if(it!=p.end())	newp[orp] = (*it).second;
	}
}

void GReAT::ConvertPacketsFromRuleToRef(const PassAlongPackets& ps,const GR::RuleBase& dstRule, PassAlongPackets& newps)
{
	for(PassAlongPackets::const_iterator i=ps.begin(); i!=ps.end(); ++i)
	{	
		PassAlongPacket newp;
		ConvertPacketFromRuleToRef(*i, dstRule, newp);
		if(newp.size() > 0)	newps.push_back(newp);
	}
}

double GReAT::calcProgress(int depth)
{
	return  max(1 - (depth+1)  *.1 , 0.0); // something
}


PassAlongPackets GReAT::Execute(const GR::RewritingRule& rule, 
                                const PassAlongPackets& arguments)
{	
  
  if(m_ctrlNotify)
  {
    m_ctrlNotify->reportProgress(calcProgress(depth));
  }

	PassAlongPackets rets;

	const string& rt = rule.ruleType();
	
	bool isfor = rule.forBlock();
	if(rt == "BLOCK")
  {
		if(isfor) 
			rets = ExecuteForBlock(rule,arguments);
		else
			rets = ExecuteBlock(rule,arguments);
  }
  else
	if(rt == "TEST")
  {
		if(isfor) 
			rets = ExecuteForTest(rule,arguments);
		else
			rets = ExecuteTest(rule,arguments);
  }
  else
	if(rt == "RULE")
		rets = ExecuteRule(rule,arguments);
  else
	if(rt == "CASE")
		rets = ExecuteCase(rule,arguments);


  if(m_ctrlNotify)
  {
	  m_ctrlNotify->reportProgress(calcProgress(depth));
  }

	return rets;
}

PassAlongPackets GReAT::ExecuteBlock(const GR::RewritingRule& rule, const PassAlongPackets& arguments)
{	
  if(m_ctrlNotify)
  {
 //   m_ctrlNotify->reportProgress(calcProgress(depth));
//	  m_ctrlNotify->reportExcuteRule((string)rule.name());
  	  string str("Executing Block: ");
	  str += (string)rule.name();
	  m_ctrlNotify->reportExcuteRule(str);
  }

	PassAlongPackets returns; 
	const string& rulename = rule.name();


//========== GR_DEBUG =========

  if (m_dbgNotify)
     m_dbgNotify->stepIn(rule, arguments);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//================================

  if(GReATOptions::instance()->printRule)
  {
	for(int it=0; it<depth; it++) cout << PRINTDEPTH;
	cout<< "Executing Block " <<  rulename << endl;	
  }

	depth++;
	set<GR::Sequence> irs = rule.dstRule();
	
	stack<pair<PassAlongPackets, GR::RuleBase> *> readyrules;
	for(set<GR::Sequence>::const_iterator i= irs.begin(); i!=irs.end(); ++i)
	{	
		const GR::Sequence& seq = *i;
		const GR::RuleBase& ir = seq.dstRule_end();
		if(GR::RewritingRule::Cast(seq.RewritingRule_parent()) != rule)
			continue;
		
		if(ir == Udm::null)	  //Why? For what case?
			continue;
		
		if(ir == rule) 	  //Recursive call here?
		{	
			PassAlongPackets rets;
			ConvertPackets(arguments, rule, rets);
			for(PassAlongPackets::const_iterator i=rets.begin(); i!=rets.end();++i)
			{	
				returns.push_back(*i);
			}
		}
		else
		{	
			readyrules.push(new pair<PassAlongPackets, GR::RuleBase>(arguments, ir));
		}
	}

	while(!readyrules.empty())
	{

		pair<PassAlongPackets, GR::RuleBase> *entry = readyrules.top();
		readyrules.pop();
		const GR::RuleBase& nextrule = entry->second;
		const string& nextrulename = nextrule.name();

		PassAlongPackets ruleargs;
		ConvertPackets(entry->first, nextrule, ruleargs);

		PassAlongPackets rulerets; 
		if(ruleargs.size() == 0) continue;

		const string& mn = nextrule.type().name();
		if(mn == "RewritingRuleProxy" )
		{	
			  if(m_ctrlNotify)
			  {
				  string str1("Executing Reference: ");
				  str1 += (string)rule.name();
				  m_ctrlNotify->reportExcuteRule(str1);
			  }

			const GR::RewritingRuleProxy& nextruler = GR::RewritingRuleProxy::Cast(nextrule);
		//	#ifdef PRINT_INFO
			  if(GReATOptions::instance()->printRule)
			  {

				for(int it=0; it<depth; it++) cout << PRINTDEPTH;
				cout<< "Executing Refeerence " << (string)nextruler.name() << endl;	
			  }
		//	#endif
			  
			PassAlongPackets newruleargs;
			ConvertPacketsFromRefToRule(ruleargs, nextruler.refersTo(),newruleargs);
			ruleargs=newruleargs;


//========== GR_DEBUG =========

  if (m_dbgNotify)
     m_dbgNotify->step(rule, nextrule, returns);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//=========================


			ruleargs = Execute(nextruler.refersTo(), ruleargs);
			ConvertPacketsFromRuleToRef(ruleargs, nextruler, rulerets);
		} 
		else
		{	

//========== GR_DEBUG =========
  if (m_dbgNotify)
     m_dbgNotify->step(rule, nextrule, returns);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//=========================

			rulerets = Execute(GR::RewritingRule::Cast(nextrule), ruleargs);
		}


		irs = nextrule.dstRule();
		for(set<GR::Sequence>::const_iterator i= irs.begin(); i!=irs.end(); ++i)
		{	
			const GR::Sequence& seq = *i;
			if(GR::RewritingRule::Cast(seq.RewritingRule_parent()) != rule)
				continue;
			const GR::RuleBase& ir = seq.dstRule_end();
			const string& irname = ir.name();
//			cout<<"Next rule "<<irname<<endl;
			if(ir == Udm::null)	continue;
			if(ir == rule) 
			{	
				PassAlongPackets rets;
				ConvertPackets(rulerets, rule, rets);
				for(PassAlongPackets::const_iterator ii=rets.begin(); ii!=rets.end();ii++)
				{
					returns.push_back(*ii);
				}
			}
			else
			{	
				readyrules.push(new pair<PassAlongPackets, GR::RuleBase>(rulerets, ir));
			}
		}
		delete entry;		  //???

   //========== GR_DEBUG =========
  
    if(m_ctrlNotify && m_ctrlNotify->quit())
       return PassAlongPackets();

   //=========================

	}

	depth--;

//========== GR_DEBUG =============
  if (m_dbgNotify)
     m_dbgNotify->stepOut(rule, returns);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();
//================================
	return returns;
}

PassAlongPackets GReAT::ExecuteForBlock(const GR::RewritingRule& rule, const PassAlongPackets& arguments)
{	
  if(m_ctrlNotify)
  {
 //   m_ctrlNotify->reportProgress(calcProgress(depth));
//	  m_ctrlNotify->reportExcuteRule((string)rule.name());
  	  string str("Executing ForBlock: ");
	  str += (string)rule.name();
	  m_ctrlNotify->reportExcuteRule(str);

  }

	PassAlongPackets returns; 
	
//#ifdef PRINT_INFO
  if(GReATOptions::instance()->printRule)
  {
	for(int it=0; it<depth; it++) cout << PRINTDEPTH;
	cout<< "Executing ForBlock " << (string)rule.name() << endl;
  }
//#endif
//	int ct = arguments.size();
	for(PassAlongPackets::const_iterator argiter=arguments.begin(); argiter != arguments.end(); ++argiter)
	{	
		PassAlongPackets onebyone;
		onebyone.push_back(*argiter);
		PassAlongPackets rets = ExecuteBlock(rule, onebyone);
		for(PassAlongPackets::const_iterator i=rets.begin(); i!=rets.end();++i)
		{	
			returns.push_back(*i);
		}
	}
	
	return returns;
}

PassAlongPackets GReAT::ExecuteForTest(const GR::RewritingRule& rule, const PassAlongPackets& arguments)
{	
  if(m_ctrlNotify)
  {
 //   m_ctrlNotify->reportProgress(calcProgress(depth));
//	  m_ctrlNotify->reportExcuteRule((string)rule.name());
  	  string str("Executing ForTest: ");
	  str += (string)rule.name();
	  m_ctrlNotify->reportExcuteRule(str);

  }

	PassAlongPackets returns; 
	
//#ifdef PRINT_INFO
  if(GReATOptions::instance()->printRule)
  {
	for(int it=0; it<depth; it++) cout << PRINTDEPTH;
	cout<< "Executing ForTest " << (string)rule.name() << endl;
  }
//#endif

//	int ct = arguments.size();
	for(PassAlongPackets::const_iterator argiter=arguments.begin(); argiter != arguments.end(); ++argiter)
	{	
		PassAlongPackets onebyone;
		onebyone.push_back(*argiter);
		PassAlongPackets  rets = ExecuteTest(rule, onebyone);
		for(PassAlongPackets::const_iterator i=rets.begin(); i!=rets.end();++i)
		{	
			returns.push_back(*i);
		}
	}
	
	return returns;
}

PassAlongPackets GReAT::ExecuteTest(const GR::RewritingRule& rule, const PassAlongPackets& arguments)
{	
  if(m_ctrlNotify)
  {
  //  m_ctrlNotify->reportProgress(calcProgress(depth));
	  string str("Executing Test: ");
	  str += (string)rule.name();
	  m_ctrlNotify->reportExcuteRule(str);
  }

	PassAlongPackets returns; 
//#ifdef PRINT_INFO
  if(GReATOptions::instance()->printRule)
  {
	for(int it=0; it<depth; it++) cout << PRINTDEPTH;
	string rulename = rule.name();
	cout<< "Executing Test " << rulename << endl;	
  }
//#endif

//========== GR_DEBUG =========
  if (m_dbgNotify)
     m_dbgNotify->stepIn(rule, arguments);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//================================

	depth++;

	set<GR::Sequence> irs = rule.dstRule();
	stack<GR::RewritingRule> readyrules;
	for(set<GR::Sequence>::const_iterator i=irs.begin(); i!=irs.end(); ++i)
	{	
		const GR::Sequence& seq = *i;
		const GR::RewritingRule& seqp = seq.RewritingRule_parent();
		const string& seqpn = seqp.name();
		if(seqp != rule)
			continue;

		const GR::RewritingRule& ir = GR::RewritingRule::Cast(seq.dstRule_end());
		
		if(ir == Udm::null)	continue;
		else
		{
			readyrules.push(ir);
			continue;
		}
	}

	while(!readyrules.empty())
	{

		GR::RewritingRule nextrule = readyrules.top();
		readyrules.pop();
		const string& nname = nextrule.name();		

//========== GR_DEBUG =========
  if (m_dbgNotify)
     m_dbgNotify->step(rule, nextrule, returns);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();
//================================

		PassAlongPackets ruleargs;
		ConvertPackets(arguments, nextrule, ruleargs);
		
		if(ruleargs.size() == 0) break;

		PassAlongPackets rets = Execute(nextrule, ruleargs);
		PassAlongPackets rerets;
		ConvertPackets(rets, rule, rerets);
		for(PassAlongPackets::const_iterator i=rerets.begin(); i!=rerets.end();++i)
		{	
			returns.push_back(*i);
		}

		if(rets.size() >0 && nextrule.cut()) break;

		irs = nextrule.dstRule();
		if(irs.size() != 1)
		{	
//			cout << "error: case has more than one next rule" << endl;
			break;
		}

		const GR::RewritingRule& ruleafter = GR::RewritingRule::Cast((*(irs.begin())).dstRule_end());
		const string& nn = ruleafter.ruleType();
		if(nn == "CASE")
			readyrules.push(ruleafter);
		else
			break;

//========== GR_DEBUG =========

  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//=========================

	}

	depth--;
//========== GR_DEBUG =========
  if (m_dbgNotify)
     m_dbgNotify->stepOut(rule, returns);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//=============================

	return returns;
}

bool GReAT::BindingPassAlongPacket(const GR::RewritingRule& rule, const PassAlongPacket& pkt)
{	
	Uml::Class poClass;
	const set<GR::ObjectWrapper>& orcs = rule.ObjectWrapper_kind_children();
	for(set<GR::ObjectWrapper>::const_iterator i=orcs.begin(); i!=orcs.end();++i)
	{	
		const GR::ObjectWrapper& grObj = (*i);
		const set<GR::PassAlong>& pa = grObj.srcObjectWrapper();
		if(pa.size()>0)
		{	
			//found in 4/21/04, when using non-memory backend, if the obj has been deleted,
			//it will throw "com exception:The object is deleted partially inaccessible"
			//found this error first with ESML_Proxy_Gen example, and obj is association class object
			try
			{
				if(pkt.find(grObj)==pkt.end()) return false;
				PassAlongPacket::const_iterator pos = pkt.find(grObj);
				const Object& obj = (*pos).second;
				
				if(obj.__impl()->__getdn()->GetRootObject()!=obj)
				{
				//if this object is not the root object, then check whether it had
				//been deleted by checking whether its parent is null object
					if(obj.GetParent()==Udm::null) return false;
				}

				if(!backendMap->GetUmlClass(grObj, poClass))	return false;
				if(!Uml::IsDerivedFrom(obj.type(), poClass))	return false;

				//1/05/04, potentia bug here, obj could be null object		
				grObj.objectID() = obj.uniqueId();
				//add new datanetwork unique id
				grObj.dataNetworkID() = obj.__impl()->__getdn()->uniqueId();
			}
			catch(udm_exception &e)
			{
				return false;
			}
		}
		else
		{	
			grObj.objectID() = 0;
			grObj.dataNetworkID() = 0;
		}
	}
	return true;
}

bool GReAT::CheckPassAlong(const GR::RewritingRule& rule)
{	
	const set<GR::ObjectWrapper>& orcs = rule.ObjectWrapper_kind_children();
	for(set<GR::ObjectWrapper>::const_iterator i=orcs.begin(); i!=orcs.end();++i)
	{	
		const set<GR::PassAlong>& pasrc = (*i).srcObjectWrapper();
		const set<GR::PassAlong>& padst = (*i).dstObjectWrapper();
		if(padst.size()>0 && pasrc.size()==0) return false;
	}
	return true;
}

bool GReAT::PackingPassAlongPacket(const GR::RewritingRule& rule, PassAlongPacket& ret)
{
	const set<GR::ObjectWrapper>& grObjs = rule.ObjectWrapper_kind_children();
	for(set<GR::ObjectWrapper>::const_iterator i=grObjs.begin();i!=grObjs.end();++i)
	{
		const GR::ObjectWrapper& grObj = *i;
		const set<GR::PassAlong>& passAlongs = grObj.dstObjectWrapper();
		if(passAlongs.empty()) continue;

		if(grObj.objectID()==0)	return false;

		Object object;
		backendMap->GetObject(grObj, object);

		if(object.__impl()->__getdn()->GetRootObject()!=object)
		{
		//if this object is not the root object, then check whether it had
		//been deleted by checking whether its parent is null object
			if(object.GetParent()==Udm::null) return false;
		}

		ret[grObj]=object;
	}
	return true;
}


void GReAT::BindingMatch(const GR::RewritingRule& rule, const Match& match)
{
//here: rule hasn't been referenced here, since the match is stored in object-->GRObject map;
//make sure that all rule is executed based on the base rule,
//take care of ruleProxy
//	if(string(rule.name())=="CreateSyncTrans") dumpoutMatch(match);
	for(map<GR::ObjectWrapper, Object>::const_iterator i=match.grObj2BoundObj.begin();\
		i!=match.grObj2BoundObj.end();++i)
	{
		((*i).first).objectID() = ((*i).second).uniqueId();
		((*i).first).dataNetworkID() = ((*i).second).__impl()->__getdn()->uniqueId();

/*		if((*i).first.objectID()==0) continue;
		string name;
		((*i).second).GetStrValue("name",name);
		cout<<(string)((*i).first.name())<<" -->  "<<name<<endl;*/
	}
}

PassAlongPackets GReAT:: ExecuteRule(GR::RewritingRule rule, const PassAlongPackets& arguments)
{	
	if(m_ctrlNotify)  
	{
		string str("Executing Rule: ");
		  str += (string)rule.name();
		  m_ctrlNotify->reportExcuteRule(str);
	}
  if(GReATOptions::instance()->printRule)
  {
	for(int it=0; it<depth; it++) cout << PRINTDEPTH;
	const string& rulename = rule.name() ;
	cout<< "Executing Rule " << rulename << endl;	
  }

	PassAlongPackets rets;
	int match_number = 0;
	for(PassAlongPackets::const_iterator i=arguments.begin();i!=arguments.end();++i)
	{
		if(BindingPassAlongPacket(rule, *i))
		{
     

//========== GR_DEBUG =========
  PassAlongPackets debug_arguments(i, arguments.end());

  if (m_dbgNotify)
     m_dbgNotify->stepIn(rule, debug_arguments);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();
//================================

	

		PatternMatcher patternMatch(rule, backendMap);
		patternMatch.findMatch();

		vector<Match>& matches = patternMatch.matches;

//		cout<<matches.size()<<endl;
		match_number += matches.size();


		if(matches.empty()) 
		{	
			if(CheckPassAlong(rule))
			{	
//				PassAlongPacket p = PackingPassAlongPacket(rule);
				rets.push_back(*i);		
			}
		}
		else
		{
			for(vector<Match>::const_iterator i=matches.begin(); i!=matches.end(); ++i)
			{	
				Match match = *i;
				BindingMatch(rule, match);

				Effector effector(&rule, backendMap);
				effector.executeRightSide(&match);

//				rets.push_back(PackingPassAlongPacket(rule));
				PassAlongPacket newp;
				if(PackingPassAlongPacket(rule, newp)) rets.push_back(newp);

				resetGRObject(rule);			
			}
		}
//========== GR_DEBUG =========
  if (m_dbgNotify)
     m_dbgNotify->stepOut(rule, rets, matches );
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//================================
    }
	}

	if(GReATOptions::instance()->printDetail)
	{
		for(int it=0; it<=depth; it++) cout << PRINTDEPTH;
		cout<<"-- InputPackets:"<<arguments.size()<<" Matches:"<<match_number
		<<" OutputPackets:"<<rets.size()<<endl;
	}
	return rets;
}

PassAlongPackets GReAT::ExecuteCase(GR::RewritingRule rule, const PassAlongPackets& arguments)
{	
  if(m_ctrlNotify)
  {
  	  string str("Executing Case: ");
	  str += (string)rule.name();
	  m_ctrlNotify->reportExcuteRule(str);

  }

//#ifdef PRINT_INFO
   if(GReATOptions::instance()->printRule)
  {
	for(int it=0; it<depth; it++) cout << PRINTDEPTH;
	cout<< "Executing Case " << (string)rule.name() << endl;	
   }
//#endif
	
// //========== GR_DEBUG =========
//   if (m_dbgNotify)
//      m_dbgNotify->stepIn(rule, arguments);
//   if(m_ctrlNotify && m_ctrlNotify->quit())
//      return PassAlongPackets();
// //================================


	PassAlongPackets rets;
	int match_number = 0;
	for(PassAlongPackets::const_iterator i=arguments.begin();i!=arguments.end();++i)
	{

		if(BindingPassAlongPacket(rule, *i))
    {
//========== GR_DEBUG =========
  PassAlongPackets debug_arguments(i, arguments.end());

  if (m_dbgNotify)
     m_dbgNotify->stepIn(rule, debug_arguments);
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();
//================================

  //		PatternMatcher patternMatch(&rule, backendMap);
		  PatternMatcher patternMatch(rule, backendMap);
		  patternMatch.findMatch();

		  const vector<Match>& matches = patternMatch.matches;

		  //cout<<matches.size()<<endl;
		  match_number += matches.size();

		  if(matches.empty()) 
		  {	
			  resetGRObject(rule);
		  }
		  else
		  {
			  for(vector<Match>::const_iterator j=matches.begin();j!=matches.end();++j)
			  {
				  const Match& match = *j;
				  BindingMatch(rule, match);
  //				rets.push_back(PackingPassAlongPacket(rule));
				  PassAlongPacket newp;
				  if(PackingPassAlongPacket(rule, newp)) rets.push_back(newp);

				  resetGRObject(rule);			
			  }
		   }
//========== GR_DEBUG =========
  if (m_dbgNotify)
     m_dbgNotify->stepOut(rule, rets, matches );
  if(m_ctrlNotify && m_ctrlNotify->quit())
     return PassAlongPackets();

//================================

    }

	}

// //========== GR_DEBUG =========
//   if (m_dbgNotify)
//      m_dbgNotify->stepOut(rule, rets);
//   if(m_ctrlNotify && m_ctrlNotify->quit())
//      return PassAlongPackets();
// 
// //================================

  	if(GReATOptions::instance()->printDetail)
	{
		for(int it=0; it<=depth; it++) cout << PRINTDEPTH;
		cout<<"-- InputPackets:"<<arguments.size()<<" Matches:"<<match_number
		<<" OutputPackets:"<<rets.size()<<endl;
	}
	return rets;
}

void GReAT::resetGRObject(const GR::RewritingRule& rule)
{
// To reset some Object ID to zero for executeRule with next match.
	const set<GR::ObjectWrapper>& grObjs = rule.ObjectWrapper_kind_children();
	for(set<GR::ObjectWrapper>::const_iterator j=grObjs.begin();j!=grObjs.end();++j)
	{
		set<GR::PassAlong> incomingPas = (*j).srcObjectWrapper();
		if(incomingPas.empty())	
		{
			(*j).objectID() = 0;
			(*j).dataNetworkID() = 0;
		}
	}
}

//==========================================

GReATOptions *GReATOptions::instance_ = 0;

GReATOptions *GReATOptions::instance()
{
	if(instance_ == 0)
		instance_ = new GReATOptions();

	return instance_;
}

bool GReATOptions::printRule = false;
bool GReATOptions::printDetail = false;
