/* NAME:	CGEx Code Generator Exception
 * AUTHOR:	Attila Vizhanyo - viza@isis-server.isis.vanderbilt.edu
 *
 * General exception class for code generation. User should catch CGEx
 * type exceptions if using code generation API.
 */
#ifndef __CGEX_H
#define __CGEX_H

#ifdef _MSC_VER
#pragma warning (disable : 4786)
#pragma warning (disable : 4503) 
#endif

#include <iostream> // for cout
#include <string>

// Code Generator Exception Class
class CGEx
{
public:
	CGEx( const std::string& exMsg) { _exMsg= exMsg; std::cout << exMsg << std::endl;}
	const std::string& what() { return _exMsg;}
private:
	std::string _exMsg;
};

#endif	//__CGEX_H

