#include "CodeGenerator.h"
#include <fstream>
#include "PEStringTable.h"
#include "GReATUtils.h"

void CodeGenerator::generate( const GR::RootFolder& grRoot)
{
	set< GR::RewritingRule> topRules= grRoot.RewritingRule_kind_children();
	for( set< GR::RewritingRule>::const_iterator itRules= topRules.begin(); itRules!= topRules.end(); ++itRules)
	{
		GR::RewritingRule rule= GR::RewritingRule::Cast( *itRules);
		_sequencer.execute( rule);
	}
}

void CodeGenerator::generateRule( const GR::RewritingRule& rule)
{
	_sequencer.execute( rule);
}

void CodeGenerator::save( const std::string name)
{
	std::string filen( name);
	std::string headern( filen+ ".h");
	std::string sourcen( filen+ ".cpp");
	std::ofstream header( headern.c_str());
	std::ofstream source( sourcen.c_str());
	// print header #include-s
	header << "#include" << SEP << "<UdmBase.h>" << std::endl;
	header << "#include" << SEP << "<cint_string.h>" << std::endl;
	const GeneralBackend::BackendMap_t& backends= _backend.getAllBackends();
	if ( false == _gzInc.empty()) {
		header << "#include" << SEP << "\"" << _gzInc << ".h\"" << std::endl << std::endl;  
	} else {
		for( GeneralBackend::BackendMap_t::const_iterator it= backends.begin(); it!= backends.end(); ++it)
			header << "#include" << SEP << "\"" << (*it).first << ".h\"" << std::endl;
	}
	// print packets typedef
	header << std::endl << "typedef std::list< Udm::Object> Packets_t;" << std::endl;
	// print generated header
	_program.printHeader( header);
	// print source #include
	source << "#include" << SEP << "\"" << dropPath( headern) << "\"" << std::endl;
	source << "#include" << SEP << "<UmlExt.h>" << std::endl;
	source << "#include" << SEP << "<UdmUtil.h>" << std::endl;
	// print generated source
	_program.printSource( source);
}


