#if !defined(GRDFrontEnd_h)
#define GRDFrontEnd_h
#include <set>
#include "IGRDFrontEnd.h"
#include "EventQueue.h"

namespace GRDI
{


class DebugInterface;
class GRDFrontEnd : public IGRDFrontEnd,
                    public EventHook
{

protected:

  DebugInterface* m_backEnd;

  EventQueue       m_events;
//  LocationIDSet    m_breakpoints;


  GRDebugNotification*  m_notify;

  ContextID        m_nextCtxID;
  ContextID        m_stepOutCtxID;

  bool              m_up;
  bool              m_runCmd;
  bool              m_stepCmd;
  bool              m_stepOutCmd;
  bool              m_nextCmd; 
  bool              m_stopCmd;
  

protected:

    void handleBreakpoint(const BreakpointEventData& breakpoint, bool pause);
    void resetFlags();
public:

    GRDFrontEnd();
    ~GRDFrontEnd() {}


    //========== IGRDFrontEnd
    void setBackEnd(DebugInterface* backEnd);
    void setNotificationInterface(GRDebugNotification* notif);
  
    void init();
    void run();
    void wait_up();
    void stop();

    bool setBreakpointCmd(const LocationID&);
    bool clearBreakpoint(const LocationID& loc);
    void clearAllBreakpoints();

    void saveCmd();
    void loadCmd(const std::string& pn);
    void closeCmd();
    void runCmd();
    void startCmd();
    void stopCmd();
    void pauseCmd();
    void nextCmd();
    void stepCmd();
    void stepOutCmd();
    void quitCmd();

    //========== 
    DebugInterface& getDebugInterface();

    //========== EventHook
    Error operator()(EventSet event);

};

};//namespace GRDI
#endif