#pragma warning(disable : 4786) 
#include "GRDebugInterface.h"
#include <limits>


namespace GRDI
{


IFunctionPtr nullFunction; 


LocationID  invalidLocationID = std::numeric_limits<LocationID>::max();

ContextID   invalidContextID = std::numeric_limits<ContextID>::max();

FunctionID  invalidFunctionID = std::numeric_limits<FunctionID>::max();
//===========================================
Location::Location():
FunctionIDLocationTypePair(invalidFunctionID,  FunctionCall),
m_caller(nullFunction),
m_called(nullFunction),
m_locID(invalidLocationID ),
m_parID(invalidLocationID ),
m_refID(invalidLocationID )
{}

const FunctionID& Location::funcID() const
{
  return first;
}

const IFunctionPtr&  Location::caller() const
{
  return m_caller;
}


const IFunctionPtr&  Location::called() const
{
  return m_called;
}


const LocationType&  Location::type() const
{
  return second;
}

Location::Location(const IFunctionPtr& caller, 
                   const IFunctionPtr& called, 
                   const LocationType& type)
                    :
 FunctionIDLocationTypePair(called->getID(),type),
 m_caller(caller),
 m_called(called),
 m_locID(invalidLocationID ),
 m_parID(invalidLocationID ),
 m_refID(invalidLocationID )
{
}


//x   Location::Location(const IFunctionPtr& caller, const IFunctionPtr& callee, const LocationType& type)
//x     : m_caller(caller), m_callee(callee), m_type(type)
//x   {
//x   }

//x   bool operator<(const Location& loc1, const Location& loc2)
//x   {
//x      return (  (loc1.m_caller < loc2.m_caller) ||  
//x                ((loc1.m_caller == loc2.m_caller) &&  (loc1.m_callee < loc2.m_callee)) ||
//x                ((loc1.m_caller == loc2.m_caller) &&  (loc1.m_callee == loc2.m_callee)) ||(loc1.m_type < loc2.m_type));
//x   }
//x
//x   bool operator==(const Location& loc1, const Location& loc2)
//x   {
//x      return (  (loc1.m_caller == loc2.m_caller) && 
//x                (loc1.m_callee == loc2.m_callee) &&
//x                (loc1.m_type == loc2.m_type));
//x   }
//x
//====================================================
ContextDescr::ContextDescr() : 
       m_id(invalidContextID),
       m_callerCtx(invalidContextID),
       m_currLocationID(invalidLocationID)
{}
//====================================================
ContextDescr::ContextDescr(
                            const ContextID& id,            
                            const FunctionCallDescr& fcd, 
                            const ContextID& caller,
                            const LocationID& currLocationID) :
m_id(id),
FunctionCallDescr(fcd), 
m_callerCtx(caller),
m_currLocationID(currLocationID)
{}
//====================================================
   Error  DebugInterface::getStatus(Status& status)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error  DebugInterface::suspend()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error  DebugInterface::resume()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
   Error DebugInterface::execute()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::run()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error DebugInterface::stop()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::pause()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::quit()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::save()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::load(const std::string&)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
   Error DebugInterface::close()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
   
 	Error DebugInterface::getContextStacktSize(int& count)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
 	Error DebugInterface::getCurrentContextID(ContextID& context)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

 	Error DebugInterface::getContextDescr(const ContextID& contextID, ContextDescr& contextDescr)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

 	Error DebugInterface::getCallerContext( const   ContextID& called,
 								                  ContextID& caller)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
 	Error DebugInterface::getCurrentLocation( const  ContextID& context,
 									                          LocationID& func)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error DebugInterface::getLastException( std::string& str)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::notifyContextPop(const ContextID& context)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error DebugInterface::setBreakpoint(const LocationID& loc)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error DebugInterface::clearBreakpoint(const LocationID& loc)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 
   Error  DebugInterface::clearAllBreakpoints()
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error  DebugInterface::getBreakPoints(LocationIDSet& breakpoints)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

//x   Error DebugInterface::getStartFunction(IFunctionPtr& rootFunc)
//x   {
//x   throw GRDException("A DebugInterface function is not implemented");
//x   return GRDI_ERROR_NONE;
//x   }

   Error DebugInterface::getRootLocations(LocationIDVec& rootLocs)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

//x   Error DebugInterface::getFunctions(FunctionDescrMap&  funcDescrMap)
//x   {
//x   throw GRDException("A DebugInterface function is not implemented");
//x   return GRDI_ERROR_NONE;
//x   }

   Error DebugInterface::getLocationFromID(const LocationID& locationID,
                                        Location& location)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }

   Error DebugInterface::getFunctionDescr(const IFunctionPtr& func,
                               FunctionDescr& descr)
   {
   throw GRDException("A DebugInterface function is not implemented");
   return GRDI_ERROR_NONE;
   }
 

   Error DebugInterface::setEventHook(EventHook* hook)
   {
     throw GRDException("A DebugInterface function is not implemented");
     return GRDI_ERROR_NONE;
   }

};//namespace GRDI

//===========================================

std::ostream& operator<<(std::ostream& stream, const GRDI::IFunction& func)
{
  func.print(stream);
  return stream;
}
//===========================================
std::ostream& operator<<(std::ostream& stream, const GRDI::IVariable& var)
{
  var.print(stream);
  return stream;
}

//===========================================
std::ostream& operator<<(std::ostream& stream, const GRDI::IVariableValue& var)
{
  var.print(stream);
  return stream;
}



