// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"

#include "Messages.h"
#include "GRDebuggerGUI.h"
#include "GRDebuggerGUIView.h"
#include "GRDebuggerGUIDoc.h"
#include <Htmlhelp.h>
#include <afxpriv.h>


#include "StackView.h"
#include "MainFrm.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_STACK, OnViewStack)
	ON_UPDATE_COMMAND_UI(ID_VIEW_STACK, OnUpdateViewStack)
	ON_COMMAND(ID_VIEW_LOG, OnViewLog)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LOG, OnUpdateViewLog)
	ON_COMMAND(ID_HELP_TEXT, OnHelpText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
  ID_STATUS_TEXT,
	ID_SEPARATOR           // status line indicator
	
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame():
m_ctrlImageList(0),
m_breakImageList(0),
m_maxPrg(0)
{
}

CMainFrame::~CMainFrame()
{
  if (m_ctrlImageList)
    delete m_ctrlImageList, m_ctrlImageList = 0;
  if (m_breakImageList)
    delete m_breakImageList, m_breakImageList = 0;
  if (m_logViewFrame)
    delete m_logViewFrame, m_logViewFrame = 0;
  if (m_stackViewFrame)
    delete m_stackViewFrame, m_stackViewFrame = 0;
}

void CMainFrame::DockControlBarNextTo(CControlBar* pBar,
                                      CControlBar* pTargetBar)
{
    ASSERT(pBar != NULL);
    ASSERT(pTargetBar != NULL);
    ASSERT(pBar != pTargetBar);

    // the neighbour must be already docked
    CDockBar* pDockBar = pTargetBar->m_pDockBar;
    ASSERT(pDockBar != NULL);
    UINT nDockBarID = pTargetBar->m_pDockBar->GetDlgCtrlID();
    ASSERT(nDockBarID != AFX_IDW_DOCKBAR_FLOAT);

    bool bHorz = (nDockBarID == AFX_IDW_DOCKBAR_TOP ||
        nDockBarID == AFX_IDW_DOCKBAR_BOTTOM);

    // dock normally (inserts a new row)
    DockControlBar(pBar, nDockBarID);

    // delete the new row (the bar pointer and the row end mark)
    pDockBar->m_arrBars.RemoveAt(pDockBar->m_arrBars.GetSize() - 1);
    pDockBar->m_arrBars.RemoveAt(pDockBar->m_arrBars.GetSize() - 1);

    // find the target bar
    for (int i = 0; i < pDockBar->m_arrBars.GetSize(); i++)
    {
        void* p = pDockBar->m_arrBars[i];
        if (p == pTargetBar) // and insert the new bar after it
            pDockBar->m_arrBars.InsertAt(i + 1, pBar);
    }

    // move the new bar into position
    CRect rBar;
    pTargetBar->GetWindowRect(rBar);
    rBar.OffsetRect(bHorz ? 1 : 0, bHorz ? 0 : 1);
    pBar->MoveWindow(rBar);
}
//=========================================


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{


	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
// 	if (!m_wndStatusBar.Create(this) ||
// 		!m_wndStatusBar.SetIndicators(indicators,
// 		  sizeof(indicators)/sizeof(UINT)))
// 	{
// 		TRACE0("Failed to create status bar\n");
// 		return -1;      // fail to create
// 	}
	
	VERIFY(m_wndProgStatusBar.Create(this));
	VERIFY(m_wndProgStatusBar.SetIndicators(indicators,
		sizeof(indicators)/sizeof(UINT)));
  m_wndProgStatusBar.SetPaneStyle(0, SBPS_NORMAL);
  m_wndProgStatusBar.SetPaneInfo(1,1, SBPS_NOBORDERS | SBPS_DISABLED,PROGRESS_MAX);

  m_maxPrg = 100;


	if (!m_ctrlToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_ctrlToolBar.LoadToolBar(IDR_CTRL))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
     m_ctrlImageList = new CImageList();
     m_ctrlImageList->Create(16, 16, ILC_MASK | ILC_COLORDDB , 16, 4);
 
 
     CBitmap start;
     start.LoadBitmap(IDB_START);
     CBitmap stop;
     stop.LoadBitmap(IDB_STOP);
     CBitmap pause;
     pause.LoadBitmap(IDB_PAUSE);
     CBitmap cont;
     cont.LoadBitmap(IDB_CONTINUE);
     CBitmap stepIn;
     stepIn.LoadBitmap(IDB_STEPIN);
     CBitmap stepOver;
     stepOver.LoadBitmap(IDB_STEPOVER);
     CBitmap stepOut;
     stepOut.LoadBitmap(IDB_STEPOUT);


     m_ctrlImageList->Add(&start, RGB(255,255, 255));
     

     m_ctrlImageList->Add(&stop, RGB(255,255, 255));
     m_ctrlImageList->Add(&pause, RGB(255,255, 255));
     m_ctrlImageList->Add(&cont, RGB(255,255, 255));
     m_ctrlImageList->Add(&stepIn, RGB(255,255, 255));
     m_ctrlImageList->Add(&stepOver, RGB(255,255, 255));
     m_ctrlImageList->Add(&stepOut, RGB(255,255, 255));

     m_ctrlToolBar.GetToolBarCtrl( ).SetImageList(m_ctrlImageList );

	if (!m_breakToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_RIGHT 
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_breakToolBar.LoadToolBar(IDR_BREAKPOINT))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

     m_ctrlImageList = new CImageList();
     m_ctrlImageList->Create(16, 16, ILC_MASK | ILC_COLORDDB  , 4, 4);
 
 
     CBitmap toogle;
     toogle.LoadBitmap(IDB_TOGGLEBREAK);
     CBitmap showBreak;
     showBreak.LoadBitmap(IDB_SHOWBREAK);
     CBitmap clearBreak;
     clearBreak.LoadBitmap(IDB_CLEARBREAK);
     CBitmap log;
     log.LoadBitmap(IDB_LOG);


     m_ctrlImageList->Add(&toogle, RGB(255,255, 255));
     m_ctrlImageList->Add(&showBreak, RGB(255,255, 255));
     m_ctrlImageList->Add(&clearBreak, RGB(255,255, 255));
     m_ctrlImageList->Add(&log, RGB(255,255, 255));

     m_breakToolBar.GetToolBarCtrl( ).SetImageList(m_ctrlImageList);


  m_logViewFrame	= new SourceViewFrame((CView*)(RUNTIME_CLASS(CGRDebuggerGUIView)->CreateObject()));
   if (!m_logViewFrame->Create(_T("Log"), this, CSize(250, 150),
        TRUE, 123))//AFX_IDW_CONTROLBAR_FIRST + 33))
   {
         TRACE0("Failed to m_sourceViewFrame\n");
         return -1;      // fail to create
 	}

  m_logViewFrame->SetBarStyle(m_logViewFrame->GetBarStyle() |
        CBRS_FLYBY | CBRS_SIZE_DYNAMIC);


  m_stackViewFrame	= new SourceViewFrame((CView*)(RUNTIME_CLASS(StackView)->CreateObject()));
  if (!m_stackViewFrame	->Create(_T("Context Satck"), this, CSize(200, 200),
       TRUE, 123))//AFX_IDW_CONTROLBAR_FIRST + 33))
  {
        TRACE0("Failed to m_sourceViewFrame\n");
        return -1;      // fail to create
	}

  m_stackViewFrame	->SetBarStyle(m_stackViewFrame->GetBarStyle() |
        CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

  m_stackViewFrame->EnableDocking(CBRS_ALIGN_ANY);	
  m_logViewFrame->EnableDocking(CBRS_ALIGN_ANY);
	m_ctrlToolBar.EnableDocking(CBRS_ALIGN_ANY);
  m_breakToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);

 
  
	DockControlBar(&m_ctrlToolBar, AFX_IDW_DOCKBAR_TOP);
  DockControlBarNextTo(&m_breakToolBar, &m_ctrlToolBar);


  DockControlBar(m_stackViewFrame, AFX_IDW_DOCKBAR_LEFT);
  DockControlBar(m_logViewFrame, AFX_IDW_DOCKBAR_BOTTOM);



	return 0;
}

//==========================================
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers




//==========================
void CMainFrame::OnViewStack() 
{
  BOOL bVisible = !m_stackViewFrame->IsWindowVisible();
  ShowControlBar(m_stackViewFrame, bVisible ? SW_SHOWNOACTIVATE : SW_HIDE, false);
}
//==========================
void CMainFrame::OnUpdateViewStack(CCmdUI* pCmdUI) 
{
  BOOL bVisible = !m_stackViewFrame->IsWindowVisible();
  if (bVisible)
    pCmdUI->SetCheck(0);
  else
    pCmdUI->SetCheck(1);
  pCmdUI->Enable( TRUE );
}
//==========================
void CMainFrame::OnViewLog() 
{
  BOOL bVisible = !m_logViewFrame->IsWindowVisible();
  ShowControlBar(m_logViewFrame, bVisible ? SW_SHOWNOACTIVATE : SW_HIDE, false);
}
//==========================
void CMainFrame::OnUpdateViewLog(CCmdUI* pCmdUI) 
{
  BOOL bVisible = !m_logViewFrame->IsWindowVisible();
  if (bVisible)
    pCmdUI->SetCheck(0);
  else
    pCmdUI->SetCheck(1);
  pCmdUI->Enable( TRUE );
}
//x//==========================
//xvoid CMainFrame::OnViewCmd() 
//x{
//x  BOOL bVisible = !m_cmdViewFrame->IsWindowVisible();
//x  ShowControlBar(m_cmdViewFrame, bVisible ? SW_SHOWNOACTIVATE : SW_HIDE, false);
//x
//x	
//x}
//x//==========================
//xvoid CMainFrame::OnUpdateViewCmd(CCmdUI* pCmdUI) 
//x{
//x  BOOL bVisible = !m_cmdViewFrame->IsWindowVisible();
//x  if (bVisible)
//x    pCmdUI->SetCheck(0);
//x  else
//x    pCmdUI->SetCheck(1);
//x  pCmdUI->Enable( TRUE );
//x
//x	
//x}

// //*************************************************************************
// // OnSetMessageString
// //*************************************************************************
// LRESULT CMainFrame::OnSetMessageString(WPARAM wParam, LPARAM lParam)
// {
// 	UINT nIDLast = m_nIDLastMessage;
// 	m_nFlags &= ~WF_NOPOPMSG;
// 
// 	CWnd* pMessageBar = GetMessageBar();
// 	if (pMessageBar != NULL)
// 	{
// 		CString sMsg;
// 		CString strMessage;
// 
// 		// set the message bar text
// 		if (lParam != 0)
// 		{
// 			ASSERT(wParam == 0);    // can't have both an ID and a string
//             			m_sStatusBarString = (LPCTSTR)lParam;
//             			sMsg = m_sStatusBarString;
// 		}
// 		else if (wParam != 0)
// 		{
// 			// map SC_CLOSE to PREVIEW_CLOSE when in print preview mode
// 			if (wParam == AFX_IDS_SCCLOSE && m_lpfnCloseProc != NULL)
// 				wParam = AFX_IDS_PREVIEW_CLOSE;
// 
// 			// get message associated with the ID indicated by wParam
//         if (wParam == AFX_IDS_IDLEMESSAGE)
//               sMsg = m_sStatusBarString;
//         else
//         {
// 	        GetMessageString(wParam, strMessage);
// 	        sMsg = strMessage;
//         }
// 		}
// 
// 		pMessageBar->SetWindowText(sMsg);
// 
// 		// update owner of the bar in terms of last message selected
// 		CFrameWnd* pFrameWnd = pMessageBar->GetParentFrame();
// 		if (pFrameWnd != NULL)
// 		{
// 			m_nIDLastMessage = (UINT)wParam;
// 			m_nIDTracking = (UINT)wParam;
// 		}
// 	}
// 
// 	m_nIDLastMessage = (UINT)wParam;    	// new ID (or 0)
// 	m_nIDTracking = (UINT)wParam;       	// so F1 on toolbar buttons work
// 
// 	return nIDLast;
// }
// 


//*************************************************************************
// StatusBarMessage
//*************************************************************************
void CMainFrame::StatusBarMessage(const CString& sReplacementText)
{

  m_statusBarTxt = sReplacementText;

  m_wndProgStatusBar.PostMessage(SET_STATUSSTRING, (LPARAM)(LPCTSTR)m_statusBarTxt );
}

//=============================
void CMainFrame::SetProgress(double prg)
{
  UINT nprg =  (UINT )(m_maxPrg * prg);
	m_wndProgStatusBar.PostMessage(SET_PROGRESS, (LPARAM) nprg);
}
//=============================
void CMainFrame::OnHelpText() 
{

  long BUFSIZE = 500;
  TCHAR tchBuf[500]; 
  CString path;
  CString hf("GRDebugHelp.chm::/home_page.GRDebugger.htm");
  if (GetEnvironmentVariable("GREAT_PATH",tchBuf, BUFSIZE))
  {
    path = CString(tchBuf);
    path +=  "\\doc\\" + hf;
  }
  else
    path = hf;

  HWND hWnd = HtmlHelp(0,path, HH_DISPLAY_TOC,  NULL) ;
	
}

// void CMainFrame::OnAppAbout() 
// {
//   CFrameWnd::OnAbout();
//    	SetDlgItemText(IDC_VERSION,_T(GREAT_VERSION));
// 
// 	
// }
