// ConfigurationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ConfigurationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "GridBtnCell_src\GridBtnCell.h"
#include "GridBtnCell_src\GridBtnCellCombo.h"
#define FIXED_ROW_COUNT         1
#define FIXED_COLUMN_COUNT      0
#define COLUMN_COUNT            5

/////////////////////////////////////////////////////////////////////////////
// CConfigurationDlg dialog

CConfigurationDlg::CConfigurationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigurationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigurationDlg)
	m_rungre = TRUE;
	m_update = FALSE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_GREICON);
}

CConfigurationDlg::CConfigurationDlg(vector<ConfigInfo> *cfgInfo, string cfgFilePath, CWnd* pParent)
	: CDialog(CConfigurationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ConfigDlg)
	m_rungre = TRUE;
	m_update = FALSE;
	//}}AFX_DATA_INIT
	configInputs = cfgInfo;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_GREICON);

	cfgPath = cfgFilePath.substr(0,cfgFilePath.find_last_of("\\")+1);
}

void CConfigurationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigurationDlg)
	DDX_Check(pDX, IDC_RUNGRE, m_rungre);
	DDX_Check(pDX, IDC_UPDATE, m_update);
	DDX_Control(pDX, IDC_GRID, m_Grid);             // associate the grid window with a C++ object

	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigurationDlg, CDialog)
	//{{AFX_MSG_MAP(CConfigurationDlg)
	ON_BN_CLICKED(IDC_RUNGRE, OnRungre)
	ON_BN_CLICKED(IDC_UPDATE, OnUpdate)
	ON_NOTIFY(GVN_ENDLABELEDIT, IDC_GRID, OnGridEndEdit)
    ON_NOTIFY(NM_CLICK, IDC_GRID, OnGridClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigurationDlg message handlers

void CConfigurationDlg::OnRungre() 
{
	// TODO: Add your control notification handler code here
	m_rungre = true;
	
}

void CConfigurationDlg::OnUpdate() 
{
	// TODO: Add your control notification handler code here
	m_update = true;	
}

void CConfigurationDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CConfigurationDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

BOOL CConfigurationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Grid.SetEditable(TRUE);
	m_Grid.SetColumnResize();

	m_Grid.SetFixedRowCount(FIXED_ROW_COUNT);
	m_Grid.SetFixedColumnCount(FIXED_COLUMN_COUNT);
	m_Grid.SetColumnCount(COLUMN_COUNT);
	m_Grid.SetRowCount(configInputs->size()+1);
	
	m_Grid.SetItemText(0, 0, CString("FileID"));
	m_Grid.SetItemText(0, 1, CString("Meta Name"));
	m_Grid.SetItemText(0, 2, CString("File Mode"));
	m_Grid.SetItemText(0, 3, CString("Open\\Create\\Update File Path"));
	m_Grid.SetItemText(0, 4, CString("Copy File Path"));

// Button
    m_BtnDataBase.SetGrid( &m_Grid);
    typedef struct
    {
        CGridBtnCellBase::STRUCT_DRAWCTL DrawCtl;  // most btn props here
        int iBtnNbr;                        // which btn within cell does this define?
        const char* pszBtnText;             // text associated with pushbutton or NULL
    }   STRUCT_CTL;


    STRUCT_CTL DrawCtlAry[] =
    { //iWidth,         sState, ucIsMbrRadioGrp,            ucAlign,     ucType, iBtnNbr, pszBtnText
        {  0,  DFCS_BUTTONPUSH, FALSE, CGridBtnCellBase::CTL_ALIGN_CENTER,DFC_BUTTON, 0, "..."}, // simple btn
    };  // (-1 iWidth's will be filled-in later)

	// Set the first fixed row background color
	int col;
	for(col=0; col<COLUMN_COUNT; ++col)
	{
		m_Grid.GetCell(0,col)->SetBackClr(RGB(0xFF, 0xFF, 0xBB));		
	}

	// Display the known FileId, MetaName, FileMode
	int row=1;
	for(vector<ConfigInfo>::iterator j=configInputs->begin();j!=configInputs->end();++j)
	{
		for(col=0; col<3; ++col)
		{
			m_Grid.SetItemState(row,col, m_Grid.GetItemState(row,col) | GVIS_READONLY);
			m_Grid.GetCell(row,col)->SetBackClr(RGB(0xFF, 0xFF, 0xE0));
		}
		CString str;
		str.Format((j->fileId).c_str());   m_Grid.SetItemText(row,0,str);
		str.Format((j->metaName).c_str()); m_Grid.SetItemText(row,1,str);
		str.Format((j->fileMode).c_str()); m_Grid.SetItemText(row,2,str);
		str.Format((j->filePath).c_str()); m_Grid.SetItemText(row,3,str);
		if(j->fileMode == "rwc" || j->fileMode == "w") 
		{
			str.Format((j->copyPath).c_str());
			m_Grid.SetItemText(row,4,str);
		}

		if(j->fileMode != "rwc") 
		{
			m_Grid.SetItemState(row,4, m_Grid.GetItemState(row,col) | GVIS_READONLY);
			m_Grid.GetCell(row,4)->SetBackClr(RGB(0xFF, 0xFF, 0xE0));
		}

		int iComboCtlWidth = GetSystemMetrics( SM_CXVSCROLL);
		int rwccol = 4;
		if(j->fileMode=="rwc") rwccol = 5;
        for (col = 3; col < rwccol; col++)
        {
            // retain old cell properties
            CGridBtnCell GridCellCopy;
            GridCellCopy.SetBtnDataBase( &m_BtnDataBase);
            CGridCellBase* pCurrCell = m_Grid.GetCell( row, col);
            if (pCurrCell)
                GridCellCopy = *pCurrCell;

            // replace standard cell with special control cell
			m_Grid.SetCellType( row, col, RUNTIME_CLASS(CGridBtnCellCombo) );
			CGridBtnCellCombo* pGridBtnCellCombo = (CGridBtnCellCombo*)m_Grid.GetCell( row, col);
			pGridBtnCellCombo->SetComboStyle( CBS_SIMPLE);

            CGridBtnCell* pGridBtnCell = (CGridBtnCell*)m_Grid.GetCell( row, col);
            pGridBtnCell->SetBtnDataBase( &m_BtnDataBase);


			pGridBtnCell->SetupBtns(0,  DFCS_BUTTONPUSH, FALSE, 
				CGridBtnCellBase::CTL_ALIGN_RIGHT, iComboCtlWidth+10, 0, "...");
		}
        
		row++;
	}

	for(col=0; col<5; ++col)
	{
		m_Grid.AutoSizeColumn(col);
	}

	m_Grid.ExpandLastColumn();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// GVN_ENDLABELEDIT
void CConfigurationDlg::OnGridEndEdit(NMHDR *pNotifyStruct, LRESULT* pResult)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
	int row = 1;
	for(vector<ConfigInfo>::iterator i=configInputs->begin();i!=configInputs->end();++i)
	{
		CString str = m_Grid.GetCell(row,3)->GetText();
		i->filePath = str;
		str = m_Grid.GetCell(row,4)->GetText();
		i->copyPath = str;
		row++;
	}
}

void CConfigurationDlg::OnGridClick(NMHDR *pNotifyStruct, LRESULT* pResult)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
    CString strMsg;

    int nRow = pItem->iRow;
    int nCol = pItem->iColumn;

    *pResult = 0;
    if( nRow < m_Grid.GetFixedRowCount() )
        return;

    CGridBtnCellCombo* pGridBtnCellCombo;

    pGridBtnCellCombo = (CGridBtnCellCombo*)m_Grid.GetCell( nRow, nCol);	
    if( !pGridBtnCellCombo->IsKindOf( RUNTIME_CLASS(CGridBtnCellCombo) ) )
    {
        return;
    }
	if( pGridBtnCellCombo->GetLastCtlClicked() < 0)
	{
		return;	
	}

	if( pGridBtnCellCombo->GetLastCtlClicked() == 0)
	{
		static char szFilter[]="UDM Backend Files (*.mga,*.xml,*.mem)|*.mga;*.xml;*.mem|\
			MGA Files(*.mga)|*.mga|XML Files (*.xml)|*.xml|\
			MEM Files (*.mem)|*.mem|All Files (*.*)|*.*||";
		bool bOpenFileDialog = true;
		DWORD dwFlags = OFN_FILEMUSTEXIST; 
		if(m_Grid.GetCell(nRow,2)->GetText() == CString("w") || nCol==4) 
		{
			bOpenFileDialog = false;
			dwFlags = OFN_OVERWRITEPROMPT;
		}

		string filepath;
		vector<ConfigInfo>::iterator pos;
		for(vector<ConfigInfo>::iterator ii=configInputs->begin();ii!=configInputs->end();++ii)
		{
			CString str = m_Grid.GetCell(nRow,0)->GetText();
			if(str==ii->fileId.c_str())
			{
				pos = ii;
				break;
	//			if(nCol==3) filepath = ii->filePath;
	//			else filepath = ii->copyPath;
			}
		}

		if(pos!=configInputs->end())
			if(nCol==3) filepath = pos->filePath;
			else filepath = pos->copyPath;		
		
		size_t strpos = filepath.find_first_of(":");
		if(strpos == string::npos && !filepath.empty()) filepath = cfgPath + filepath;

//		LPCTSTR lpszFileName(filepath.c_str());
//		if(filepath.empty()) lpszFileName = NULL;

		CFileDialog dlgDOM(bOpenFileDialog,"",NULL,dwFlags,szFilter,NULL);
		if(dlgDOM.DoModal()==IDOK)
		{	
			m_Grid.SetItemText(nRow,nCol,dlgDOM.GetPathName());
			m_Grid.RedrawCell( nRow, nCol);
			UpdateData(TRUE);

/*			for(vector<ConfigInfo>::iterator i=configInputs->begin();i!=configInputs->end();++i)
			{
				CString str = m_Grid.GetCell(nRow,0)->GetText();
				if(str==i->fileId.c_str())
				{
					if(nCol==3) i->filePath = dlgDOM.GetPathName();
					else i->copyPath = dlgDOM.GetPathName();
				}
			}
*/
			if(nCol==3) pos->filePath = dlgDOM.GetPathName();
			else pos->copyPath = dlgDOM.GetPathName();
		}
	}
}
